Program CrosswordMania;

{$X+ }  { Enable extended syntax }

{ SPX library - Copyright 1994 Scott D. Ramsay  }
Uses
crt,
spx_key,
spx_vga,
spx_gui,
spx_fnc,
spx_sfn,
spx_mos;

const

  gridsize = 15; {Size of crossword in tiles across and down}

  ErrorCode:boolean=false;
           path = '';   { default work path }
  nsize:integer = 10;   {cycle amplitude for title screen}
  hsize:integer = 100;  {cycle period for title screen}


{Constants used if virtual window is ever implemented}
{----------------------------------------------------------------}
  gmx   = 15;                    { tilemap width }
  gmy   = 15;                    { tilemap height }
  gsx   = 16;                    { tile width }
  gsy   = 16;                    { tile height }
  smx   = gmx*gsx;               { tilemap width in pixels }
  smy   = gmy*gsy;               { tilemap height in pixels }
  speed : integer = 4;           { scrolling speed of tiles}
{----------------------------------------------------------------}


var

      across : boolean;

       score : integer;

       s     : string;



correctarray : array[1..gridsize, 1..gridsize] of char;
               {contains the letters the player
               has entered correctly}

    numarray : array[1..gridsize, 1..gridsize] of integer;
               {numbers showing which squares should be numbered,white,black}

    letarray : array[1..gridsize+2, 1..gridsize+2] of char;
               {used in number finding algorithm}
               {letters & semicolons from XWD file and semicolon border}

   soluarray : array[1..gridsize, 1..gridsize] of char;
               {ready for checking solutions}
               {letters & semicolons from XWD file}

 playerarray : array[1..gridsize, 1..gridsize] of char;
               {letters player has entered}
               {to be compared against soluarray}

 wrongarray  : array[1..gridsize, 1..gridsize] of boolean;
               {boolean flags on finding correct values}
               {if hint button is off}

      solved : boolean;
      hint   : boolean;
      cheater  : boolean;

  row:integer;
  column:integer;

  cradio : integer;            { variable to keep track of which }
                               { radio button is enabled }

     list : TobjList;           { list to contain all objects }
     p,q  : pButton;            { object pointers }
     pr   : integer;
     quit : boolean;


procedure initspace;
var
 I,J:integer;

begin
for I:=1 to gridsize do
  for J:=1 to gridsize do
    correctarray[J,I]:='~';
    if (soluarray[J,I]<>';') then
      begin
           playerarray[J,I]:=' ';
      end;
end;

{ Initalize variables and create buttons, scrollers, etc }
procedure setbuttons;
var
  p : pbutton;
begin
  hint:=false;
  across:=true;   { sets default to across }
  cheater:=false;
  list.init;      { init object structure }
  cradio := 4; { Set radios to Default }
  with list do
    begin
     { create QUIT, LOAD, and SOLVE buttons }
      addobject(new(pbutton,init(198,00,38,20,1,#27,false,'|ESC| Quit')));
      addobject(new(pbutton,init(239,00,38,20,2,'L',false,'|L|oad')));
      addobject(new(pbutton,init(279,00,38,20,3,'S',false,'|S|ave')));

     { create ACROSS and DOWN radio buttons }
      addobject(new(pradio,init(198,20,59,20,4,1,'A',false,'|A|cross',cradio=4)));
      addobject(new(pradio,init(257,20,58,20,5,1,'D',false,'|D|own',cradio=5)));

     { create pick box for ACROSS and DOWN clues}
      addobject(new(ppbox,init(196,36,123,10,7,'Across')));
      addobject(new(ppbox,init(196,106,123,10,8,'Down')));

     { create SHOW, SOLVE, and ABOUT buttons }
      addobject(new(pcheck,init(198,179,40,20,9,'c',false,'|C|heat',false)));
      addobject(new(pbutton,init(239,179,40,20,10,'k',false,'Chec|k|')));
      addobject(new(pcheck,init(279,179,40,20,11,'h',false,'|H|int',false)));
      addobject(new(pbutton,init(0,0,198,198,12,'~',false,'~')));
    end;
end;

{ Setup Graphics mode for GUI }
procedure setupgame;
begin
  score:=0;
  openmode(2);      { open graphics mode with 1 virtual page }
  cls(cl[1]);       { clear screen to desktop color }
  setpageactive(2); { set page 2 as the active page }
  setbuttons;       { set object buttons }

{ check if mouse exist, display message if not found }
  if mousereset=0
     then
         begin
              message('Mouse not installed',true);
         end
       else
         begin
            setdefptr;     { Set the default mouse pointer shape }
            mouseon;       { Make the mouse pointer visible }
         end;
  clearbuffer;   { Clear the keyboard buffer }
end;


(***********************************************)

Procedure ReadDatFile(fname:string);

   var
      inchar: char;
      a,b,m,n : integer;
      infile: text;
   Begin
      assign(infile, fname);
      reset(infile);
      a:=2;
      b:=2;
      for n:=1 to gridsize do
         begin
            for m:=1 to gridsize do
               begin
                  read(infile, letarray[a,b]);
                  b:=b+1;
               end; {while loop}
            read(infile,inchar);
            read(infile,inchar);
            a:=a+1;
            b:=2;
         end; {while loop}

      for b:=1 to (gridsize+2) do
         begin
            letarray[1,b]:= ';';
            letarray[gridsize+2,b]:= ';';
            letarray[b,1]:= ';';
            letarray[b,gridsize+2]:= ';';
         end; {for loop}
     close(infile);
   End; {procedure READIN}

Procedure FINDNUM;
   var
      a,b,num : integer;
   Begin {procdure FINDNUM}
      for a:=1 to gridsize do
         for b:=1 to gridsize do
            numarray[a,b]:=99;
      num:=1;
      for a:=2 to gridsize+1 do
         begin
            for b:=2 to gridsize+1 do
               begin
                  if letarray[a,b] <> ';' then
                     begin
                        if (letarray[a-1,b]=';') or (letarray[a,b-1] = ';') then
                           begin
                              numarray[a-1,b-1]:=num;{numbered square}
                              num:=num+1;
                           end {if-then loop}
                           else numarray[a-1,b-1]:=0; {white square}
                     end {if-then loop}
                     else numarray[a-1,b-1]:=-1; {black square}
               end; {for loop}
         end; {for loop}
   end; {procedure}

{ Will take the letarray that has the extra ;s and convert it to a
  simple gridsize x gridsize 2D array with letters and semicolons. }

Procedure PRETTYLET;
   var
      a,b,j,k : integer;
   Begin
      for a:=2 to (gridsize+1) do
         begin
            for b:=2 to (gridsize+1) do
               begin
                  soluarray[a-1,b-1]:=letarray[a,b];
               end;{for loop}
         end; {for loop}
   end; {procedure}

{Start of putting tiles on screen}

procedure cheat;
begin
    mouseoff;             { hide the mouse }

    if cheater=true then
    begin
        for column:=1 to gridsize do
        begin
         for row:= 1 to gridsize do
         begin
              {paints a white square with a number}
              if numarray[row,column] > 0 then
                 begin
                    bar(column*13-12,row*13-12,column*13-1,row*13-1,15);
                    {paints square number}
                    putletter(column*13-11,row*13-11,23,st(numarray[row,column]));
                    {paints answer}
    {******}        putchar(column*13-8,row*13-5,soluarray[row,column],9);
                 end
              else

              {paints a white square without a number}
              if numarray[row,column] = 0 then
                 begin
                        bar(column*13-12,row*13-12,column*13-1,row*13-1,15);
                        {shows answer}
    {******}            putchar(column*13-8,row*13-5,soluarray[row,column],9);
                 end;
         end;
        end;
    end
    else
    begin
        mouseoff;
        for column:=1 to gridsize do
        begin
         for row:= 1 to gridsize do
         begin
              {This method loaded PCX tiles... slooowwww.....}
              {loadspcx(path+st(numarray[row,column])+'.pcx',column*13-12,row*13-12);}

              {paints a white square with a number}
              if numarray[row,column] > 0 then
                 begin
                    bar(column*13-12,row*13-12,column*13-1,row*13-1,15);
                    {paints square number}
                    putletter(column*13-11,row*13-11,23,st(numarray[row,column]));
                    {paints answer}
    {******}        {putchar(column*13-8,row*13-5,soluarray[row,column],5);}
                 end
              else

              {paints a white square without a number}
              if numarray[row,column] = 0 then
                 begin
                        bar(column*13-12,row*13-12,column*13-1,row*13-1,15);
                        {shows answer}
    {******}            {putchar(column*13-8,row*13-5,soluarray[row,column],5);}
                 end
              else

              {paints a black square without a number}
              if numarray[row,column] = -1 then
                 begin
                    bar(column*13-12,row*13-12,column*13-1,row*13-1,0);
                 end;
        end
       end;
    mouseon;
    end;

    for column:=1 to gridsize do
    begin
         for row:= 1 to gridsize do
         begin
              if correctarray[row,column]<>'~' then
                 begin
                      if numarray[row,column] > 0 then
                         begin
                              bar(column*13-12,row*13-12,column*13-1,row*13-1,15);
                              {paints square number}
                              putletter(column*13-11,row*13-11,23,st(numarray[row,column]));
                              {paints answer}
                              putchar(column*13-8,row*13-5,correctarray[row,column],0);
                         end
                         else

                         {paints a white square without a number}
                         if numarray[row,column] = 0 then
                            begin
                                 bar(column*13-12,row*13-12,column*13-1,row*13-1,15);
                                 {shows answer}
                                 putchar(column*13-8,row*13-5,correctarray[row,column],0);
                            end;
                 end;
         end;
    end;

    mouseon;
end;

procedure printtiles;
begin
    mouseoff;             { hide the mouse }

    PRETTYLET;

    for column:=1 to gridsize do
    begin
         for row:= 1 to gridsize do
         begin
              {This method loaded PCX tiles... slooowwww.....}
              {loadspcx(path+st(numarray[row,column])+'.pcx',column*13-12,row*13-12);}

              {paints a white square with a number}
              if numarray[row,column] > 0 then
                 begin
                    bar(column*13-12,row*13-12,column*13-1,row*13-1,15);
                    {paints square number}
                    putletter(column*13-11,row*13-11,23,st(numarray[row,column]));
                    {paints answer}
    {******}        {putchar(column*13-8,row*13-5,soluarray[row,column],5);}
                 end
              else

              {paints a white square without a number}
              if numarray[row,column] = 0 then
                 begin
                        bar(column*13-12,row*13-12,column*13-1,row*13-1,15);
                        {shows answer}
    {******}            {putchar(column*13-8,row*13-5,soluarray[row,column],5);}
                 end
              else

              {paints a black square without a number}
              if numarray[row,column] = -1 then
                 begin
                    bar(column*13-12,row*13-12,column*13-1,row*13-1,0);
                 end;
        end
    end;
    mouseon;
end;

{ Redraw the screen and objects: Draw on page 2 then update to }
{ reduce redrawing flicker }

procedure redrawscreen;
begin
  setpageactive(2);     { set to page 2 }
  cls(cl[1]);           { clear the screen }
  list.showall;            { draw all objects }
  mouseoff;             { hide the mouse }
  pcopy(2,1);           { update the visual page }
  mouseon;              { turn the mouse back on }
  setpageactive(1);     { set page 1 as the active page }
end;


Procedure gettilepos(var xcoord, ycoord:integer);
var
   checkx,checky,mmouse,mousex,mousey:integer;

begin
   getmouse(mmouse,mousex,mousey);
   checkx:=(mousex div 13)+1;
   if checkx <= gridsize then
      xcoord:=checkx
      else
         xcoord:=-999;
   checky:=(mousey div 13)+1;
   if checky<=gridsize then
      ycoord:=checky
      else
         ycoord:=-999;
end;

procedure printclues;
begin
end;

procedure errormessage(error:integer);
{This procedure will assign an appropriate error message to the input the
  user has given....}

begin
  mouseon;
  case error of
    1:message('You have inputed a value that is out of range!!',true);
    2:message('This space is not a valid input location!!',true);
    3:message('You have entered an unacceptable value!!',true);
    4:message('You have input an incorrect value!!',true);
    5:message('You have already input the correct value!!',true);
    6:message('You have an error in your puzzle!!',true);
    7:message('You need a value in each square before checking!',true);
    8:message('YOUR NOT DONE YET!!!!',true);

  end;
  mouseoff;
end;

procedure findscore(var total:integer;  score:integer);
{this procedure will calculate the users score}
begin
  total:=total+score;
end;

procedure checkcross(xcoord,ycoord:integer; var score:integer; hint:boolean);
{checks memory for to see if character inputed is correct and treats
    differently depending on your level.  This procedure is used a lot as
    well because it checks each character you input.}
var
  loser:string;
  question:boolean;

begin
  if (playerarray[ycoord,xcoord]<>soluarray[ycoord,xcoord]) then
    begin
      if (hint=true) then
        begin
          errormessage(4);
          if (yes('Would you like the correct answer?')) then
            begin
              correctarray[ycoord,xcoord]:=soluarray[ycoord,xcoord];
              playerarray[ycoord,xcoord]:=soluarray[ycoord,xcoord];
              findscore(score, -2);
            end
          else
            playerarray[ycoord,xcoord]:=' ';
        end    {end if-statement}
      else
        begin
          wrongarray[xcoord,ycoord]:=true;
          findscore(score, -3);
        end;
    end     {end if-statement}
  else
    begin

      correctarray[ycoord,xcoord]:=playerarray[ycoord,xcoord];

      wrongarray[xcoord,ycoord]:=false;
      if hint=true then
        findscore(score, 2)
      else
        findscore(score, 4);
    end;
end;

procedure checkforblanks(var blanks:boolean; var score:integer; breakout:boolean);
{This procedure will look for blanks and if it finds any it is supposed
  to output an error message and not move on to check for correct characters.}
var
  I,J:integer;

begin
  for I:=1 to gridsize do
    begin
      if breakout=false then            {needed to break loop}
        begin
          for J:=1 to gridsize do
            begin
              if (playerarray[J,I]=' ') then
                begin
                  errormessage(7);         {Youre not done yet dummy!!!}
                  findscore(score, -10);
                  blanks:=true;
                  breakout:=true;          {will break second loop}
                  break;                   {breaks first loop}
                end;  {end if-statement}
            end;  {end for-loop}
        end  {end break if-statement}
      else
        break;  {actually breaks second loop}
    end;  {end for-loop}
end;

procedure checkifsolved(var solved:boolean; var score:integer);
{This will look to see if the crossword is solved and if it is then it will
  output that you have won.  Otherwise it will output appropriate error
  messages and then break out.}
var
  I,J:integer;
  breakout:boolean;
  blanks:boolean;

begin
  blanks:=false;
  breakout:=false;
  checkforblanks(blanks, score, breakout);  {will look for blanks}
  breakout:=false;
  if blanks=false then       {checks to see if there were blanks}
    begin
      for I:=1 to gridsize do
        begin
          if breakout=false then       {checks if you want to exit loop}
            begin
              for J:=1 to gridsize do
                begin
                  if (wrongarray[I,J]=true) then     {looks for boolean flags}
                    begin
                      errormessage(6);                 {you have an error message}
                      if (yes('Would you like help?')) then   {asks for help}
                        begin
                          findscore(score, -2);
                          if hint=true then
                            begin
              if (yes('The error is in row '+st(J)+' and column '+st(I)+'!  Would you like the solution?')) then
                                begin
                                  playerarray[J,I]:=soluarray[J,I];{gives the answer}
                                  wrongarray[I,J]:=false;  {puts correct flag}
                                  findscore(score, -5);
                                end    {end if-statement}
                              else
                                begin
                                  playerarray[J,I]:=' ';   {makes blank}
                                  findscore(score, -2);
                                  wrongarray[I,J]:=false;  {still correct location}
                                  breakout:=true;    {break boolean}
                                  break;           {breaks loop}
                                end;    {end else-statement}
                            end    {end if-statement}
                          else
                            begin
                              message('The error is in row '+st(J)+' and column '+st(I)+'!',true);
                              playerarray[J,I]:=' ';  {makes blank spot}
                              wrongarray[I,J]:=false;   {still correct location}
                              findscore(score, -2);
                              breakout:=true;   {break boolean}
                              break;            {breaks loop}
                            end;    {end else-statement}
                        end     {end if-statement....would you like help}
                      else
                        begin
                          message('Okay, back to the drawing board!!',true);  {Don't need help}
                          findscore(score, 1);
                          breakout:=true;     {break boolean}
                          break;              {breaks loop}
                        end;  {end else-statement}
                    end
                  else
                  if (((I=15) and (J=15)) and (wrongarray[I,J]=false)) then
                    begin
                      solved:=true;            {it's solved}
                      findscore(score, 50);
                      message('You have won!!!',true);    {you won}
                      breakout:=true;      {break boolean}
                      break;               {breaks loop}
                    end;     {end if-statement}
                end;   {end for-loop}
            end    {end if-statement to exit loop}
          else
            begin               {**don't think i need this else**}
              errormessage(8);  {your not done yet error message}
              break;
            end;    {end else-statement}
        end;    {end for-loop}
    end;    {end if-statement checking for blanks}
end;


procedure movenext(var I,J:integer);
{moves pointer after input}

begin

  if (across) then
    begin
    {message('across',true);}
      if key[key_esc] then
        begin
          I:=-1;
          J:=-1;
        end;
      if ((soluarray[I,J+1]=';') or (J=15)) then
        begin
          I:=-1;
          J:=-1;
        end
      else
        J:=J+1;
    end
  else
  if not(across) then
    begin
    {message('not across',true);}
      if key[key_esc] then
        begin
          I:=-1;
          J:=-1;
        end;
      if ((soluarray[I+1,J]=';') or (I=15)) then
        begin
          I:=-1;
          J:=-1;
        end
      else
        I:=I+1;
    end;
end;


function GetClueFile(fname:string):string;
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-
Module Name: getcluefile
Description: grabs the clue file from memory
Input: none
Output: none
Calls: getcluefile

Created: April 27, 1997
Last Modified:
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-}
Var
   cluname : string;
   len, n : integer;
Begin
   len:=length(fname);
   for n:=1 to (len-3) do
      cluname[n]:=fname[n];
   cluname[len-2]:='C';
   cluname[len-1]:='L';
   cluname[len]:='U';
   cluname[0]:=chr(ord(len));
   GetClueFile:=cluname;
end; {function}

Procedure LoadClueFile(s:string; p:pbutton);
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-
Module Name: loadcluefile
Description: takes the clues and inputing them into memory.
Input: none
Output: the clues into scroll bars
Calls: getcluefile

Created: April 27, 1997
Last Modified:
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-}

Var
   TempF : text;
   TempData:string;        {holds the data from the input file}
   inchar: char;
   fname: string;

begin
   FName:=GetClueFile(s);
   assign (TempF, FName);
   reset(TempF);
   {reads in the across clues}
   tempdata:='';
   {while tempdata<>';' do}
   with list do
      begin
         if not eof(TempF) then
            read(TempF, inchar);
         while (inchar<>';') do
            begin
               while (inchar<>chr(13)) and (inchar<>chr(10)) do  {Readln workaround}
                  begin
                     if not eof(TempF) then
                        begin
                           tempdata:=tempdata+inchar;
                           read(TempF, inchar);
                        end
                  end; {while loop}
               {add a string to the pick box }
               ppbox(p)^.additem(TempData,0,true);
               {reinitialize tempdata for next iteration}
               tempdata:='';
               if not eof(TempF) then
                  read(TempF,inchar); {takes care of CR/LF}
               if not eof(TempF) then
                  read(TempF,inchar);
            end; {while inchar<>';' loop}
            {start of DOWN section}
         P:= retobject(8);  {Load object handle for Down box}
         if not eof(TempF) then
            read(TempF, inchar); {takes care of CR}
         {reinitialize tempdata for next iteration}
         tempdata:='';
         if not eof(TempF) then
            read(TempF,inchar); {takes care of LF}

         (*if not eof(TempF) then
            read(TempF,inchar); {read in first char of down clues} *)
         while not eof(TempF) do
            begin
                 if not eoln(TempF) then
                    begin
                         read(TempF, inchar);
                         tempdata:=tempdata+inchar;
                    end
                    else
                    begin
                         {add a string to the pick box }
                         ppbox(p)^.additem(TempData,0,true);

                         {reinitialize tempdata for next iteration}
                         {tempdata[0]:=chr(ord(0));}
                         tempdata:='';

                         if not eof(TempF) then
                            begin
                                 read(TempF,inchar); {takes care of CR/LF}
                                 {message('the first char: '+inchar,true);}
                            end
                            else
                            begin
                                 message('eof(TempF) true at CR',true);
                            end;

                         if not eof(TempF) then
                            begin
                                 read(TempF,inchar);
                                 {message('the second char: '+inchar,true);}
                            end;
                    end;
            end; {while not eof(TempF)}
      end; {with}

   {$I-} {Turn IO checking of to trap I/O errors}
   close(TempF);
   {$I+} {Turn IO checking back on }
   {message('close(TempF) IOResult should be 0 --> '+st(IOResult),true);}
{  yes('clue file has been closed');}
end;



{ Check the return handle values and does the button's functions }

procedure CheckButtons(pr:integer;p:pbutton);
{ pr:integer;  Handle number of the object that was activated }
{ p:pbutton;   pointer to the activated object }
var
  randomcolors : wcolortypes;
  t            : integer;
  xcoord,ycoord: integer;
  inchar       : char;
begin
     gettilepos(xcoord, ycoord);
  with list do
    case pr of
     { button - call disk dialog box }
      2 : begin
            s := diskdo(24,10,'puzz39.xwd','XWD','Select a game to load',true);
            if s<>''
              then
                  begin
                       {message('File is '+s,true);}
                       ReadDatFile(s);
                       findnum;
                       redrawscreen;
                       printtiles;
                       printclues;
                       p := retobject(7);
                       LoadClueFile(s,p);
                       clearbuffer;
                       initspace;
                  end
                  else
                  begin
                       {redrawscreen;} {this will erase the grid}
                  end;
          end;

     {  SAVE what the user has figured out }
      3 : begin
               message('Save routine goes here',true);
          end;

     { ACROSS - Scroll Box}

     4 :begin
             across:=true;
             if pcheck(p)^.tchk then
             begin
                  {get a pointer to the pick box object }
                  p := retobject(7);
                  {clear keyboard buffer and mouse presses }
                  clearbuffer;
                  end;
             end;

      {DOWN - Scroll Box}
       5 : begin
                across:=false;
                if pcheck(p)^.tchk then
                   begin
                        {get a pointer to the pick box object }
                        p := retobject(8);
                        { clear keyboard buffer and mouse presses }
                        clearbuffer;
                   end;
           end;


      6: begin
         end;

      7: begin
              {This is where we could select a clue from the across pickbox}
         end;

      8: begin
              {This is where we could select a clue from the down pickbox}
         end;


      9 : begin
             if s <> '' then
             begin

             if pcheck(p)^.tchk then
               cheater:=true         {showes all answers in blue}
             else
               cheater:=false;       {erases answers in blue}

(*                  if cheater=true then
                     begin
                          cheater:=false;
                     end
                     else
                     begin
                          cheater:=true;
                     end;
*)
                  cheat;
             end
             else
             begin
                 pcheck(p)^.tchk:=false;
                 mouseoff;
                 bar(228, 188, 229, 189, 23);
                 mouseon;
                 message('You have not selected a puzzle yet!',true);
             end;
           end;


      10 : begin
             if s <> '' then
             begin
                  checkifsolved(solved, score);
             end
             else
                 message('You have not selected a puzzle yet!',true);
           end;

      {HINT - Hint button}
      11 : begin
             if pcheck(p)^.tchk then
               hint:=true         {gives hints if character is incorrect}
             else
               hint:=false;       {doesn't give hints, but puts up flag}
           end;
     { crosswordgrid object - }
      12 : begin
                if s<>'' then
                begin
                  if xcoord > 0 then
                   begin
                        if soluarray[ycoord,xcoord]<>';' then
                          begin
                           repeat
                           {start highlighting tile}
                                mouseoff;
                                bar(xcoord*13-12,ycoord*13-12,xcoord*13-1,ycoord*13-1,5);
                                {paints tile number in upper left corner}
                                if numarray[ycoord,xcoord] <> 0 then
                                  begin
                                       putletter(xcoord*13-11,ycoord*13-11,15,st(numarray[ycoord,xcoord]));
                                  end;
                            {end highlight tile}

                            {get character input from user}
                                inchar:=upcase(readkey);
                                if inchar <> chr(27) then {if the user didn't hit ESC}
                                begin
                                     playerarray[ycoord,xcoord]:=inchar;
                                     putchar(xcoord*13-8,ycoord*13-5,playerarray[ycoord,xcoord],11);

                                     {character by character check if hint=true}
                                     checkcross(xcoord, ycoord, score, hint);
                                     bar(227, 39, 310, 46, 23);
                                     drawletter(260, 40,15,8,'Score  '+st(score));
                                     {put tile back to original color}
                                     bar(xcoord*13-12,ycoord*13-12,xcoord*13-1,ycoord*13-1,15);

                                     {put letter on tile back to original color }
                                     putchar(xcoord*13-8,ycoord*13-5,playerarray[ycoord,xcoord],0);

                                     {put number on tile back to original color}
                                     if numarray[ycoord,xcoord] <> 0 then
                                     begin
                                          putletter(xcoord*13-11,ycoord*13-11,23,st(numarray[ycoord,xcoord]));
                                     end;
                                     movenext(ycoord,xcoord);
                                     {message('ycoord is: '+st(ycoord),true);}
                                     {message('xcoord is: '+st(xcoord),true);}
                                end
                                else
                                begin
                                     {put tile back to original color}
                                     bar(xcoord*13-12,ycoord*13-12,xcoord*13-1,ycoord*13-1,15);

                                     {put letter on tile back to original color }
                                     putchar(xcoord*13-8,ycoord*13-5,playerarray[ycoord,xcoord],0);

                                     if cheater=true then  { repaints the tile with the blue letter }
                                     begin
                                          {paints a white square with a number}
                                          if numarray[ycoord,xcoord] > 0 then
                                          begin
                                               bar(xcoord*13-12,ycoord*13-12,xcoord*13-1,ycoord*13-1,15);
                                               {paints square number}
                                               putletter(xcoord*13-11,ycoord*13-11,23,st(numarray[ycoord,xcoord]));
                                               {paints answer}
    {******}                                   putchar(xcoord*13-8,ycoord*13-5,soluarray[ycoord,xcoord],9);
                                           end
                                           else

                                           {paints a white square without a number}
                                           if numarray[row,column] = 0 then
                                           begin
                                                bar(xcoord*13-12,ycoord*13-12,xcoord*13-1,ycoord*13-1,15);
                                                {shows answer}
    {******}                                    putchar(xcoord*13-8,ycoord*13-5,soluarray[ycoord,xcoord],9);
                                           end;
                                     end;

                                     {put number on tile back to original color}
                                     if numarray[ycoord,xcoord] <> 0 then
                                     begin
                                          putletter(xcoord*13-11,ycoord*13-11,23,st(numarray[ycoord,xcoord]));
                                     end;
                                end;

                            until ( ((ycoord=-1) and (xcoord=-1)) ) or (inchar=chr(27));
                                mouseon;
                            {message('we are at -1x-1',true);}
                            end

                        {message('tile X is '+st(xcoord),true);
                        message('tile Y is '+st(ycoord),true);}
                   end;
                end;
           end;
    end;
end;

{ Event loop }
procedure eventloop;

  var
    pr : integer; { keeps track of return handles }
    p  : pbutton; { pointer to any activated objects }
    xcoord, ycoord:integer;

  begin
       redrawscreen; { draw screen }
       with list do
         repeat
            begin
               inkey;                 { grab, keyboard and mouse values }
               pr := CheckPress(p);   { scan, objects for actvation }
               if pr<>0               { if CHECKPRESS returns a non-zero val, }
                                { then an object was pressed or activated }
                  then CheckButtons(pr,p) { handle object }
            end; {repeat - until loop}
         until (pr=1) and yes('Quit Crossword Mania?'); { ask if want to quit. }
  end;

{ do some clean up }
procedure cleanup;
begin
  list.done;    { deallocate object variables }
  closemode; { close graphics mode }
end;

begin
  setupgame;
  eventloop;
  cleanup;
end.